#ifdef GL_ES
precision mediump float;
#endif
varying vec2 v_texCoord;
varying vec4 v_position;
uniform sampler2D u_normalText;
uniform vec4 u_bPoint;
uniform vec4 u_tPoint;
uniform vec4 u_offset;
uniform vec4 u_param1;
uniform vec4 u_param2;

#define PI 3.1415926

bool containPoint()
{
	   bool bRet = false;
		 vec2 point=vec2(v_position);
    if (point.x >= u_bPoint[0] && point.x <= u_tPoint[2]
        && point.y >= u_bPoint[1] && point.y <= u_tPoint[3])
    {
        bRet = true;
    }
		
  return bRet;	
}

vec2 calcOffset()
{
	float x=u_offset[0];
	float y=u_offset[1];
	float offsetX=u_offset[2];
	float offsetY=u_offset[3];
	vec2 point=vec2(v_position);
	vec2 middle=vec2(x,y);
	float length=distance(middle,point);

	return vec2(-(point-middle).x*offsetX/length,(point-middle).y*offsetY/length);
}



bool isHit(float angle)
{
		if(angle>=2.0*PI)
		{
				angle=angle-2.0*PI;
		}
		float minAngle=angle-u_param2[0];
		float maxAngle=angle+u_param2[0];
		if(minAngle<0.0)
		{
			minAngle=PI*2.0+minAngle;
		}
		if(maxAngle>=2.0*PI)
		{
			maxAngle=maxAngle-PI*2.0;
		}
		float x=u_offset[0];
		float y=u_offset[1];
		vec2 point=vec2(v_position);
		vec2 middle=vec2(x,y);
		vec2 dir=point-middle;
		angle=atan(dir.y,dir.x);
		if(angle<0.0)
		{
				angle=PI*2.0+angle;
		}
		if(maxAngle>minAngle&&angle>=minAngle&&angle<=maxAngle)
		{
			return true;
		}
		if(maxAngle<minAngle&&(angle>=minAngle||angle<=maxAngle))
		{
			return true;
		}
		
		return false;
}

vec4 composite(vec4 over, vec4 under)  
{  
	return over + (1.0 - over.a)*under;  
}  

void main()
{
		bool result=containPoint();
		vec2 offset=calcOffset();
		vec4 textureColor;
		const float shadowOpacity = 0.5; 
		bool hit=isHit(u_param1[3]);
		if(!hit)
		{
			hit=isHit(u_param1[3]+PI);
		}
		if(!result)
		{
			if(!hit)
			{
					discard;
					return;
			}
			textureColor=texture2D(u_normalText, v_texCoord+offset);
			if(textureColor.a<=0.35)
			{
				discard;
			}else
			{
					textureColor=vec4(vec3(u_param1),textureColor.a*shadowOpacity);
					gl_FragColor=composite(vec4(0.0,0.0,0.0,0.0),textureColor);
			}
			return;
		}
		
	  textureColor=texture2D(u_normalText, v_texCoord);
	  if(!hit)
		{
					gl_FragColor = textureColor;
					return;
		}
	  if(textureColor.a>=0.9)
	  {
	  	gl_FragColor = textureColor;
	  	return;
	  }
	  vec4 offsetTextureColor=texture2D(u_normalText, v_texCoord+offset);
	  /*if(textureColor.a<=0.35)
			{
			discard;
			return;
			}
	  
		*/
		offsetTextureColor=vec4(vec3(u_param1),offsetTextureColor.a*shadowOpacity);
		gl_FragColor=composite(textureColor,offsetTextureColor);
		
}