#ifdef GL_ES
precision highp float;
#endif
varying vec2 v_texCoord;
uniform sampler2D u_NormalText; // 0
uniform sampler2D u_IceText;
uniform sampler2D u_BumpText;
uniform float u_RndFactor ;
uniform vec4 u_HoldParam;
/*
float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

float rand2(vec2 co)
{
     float a = 12.9898;
     float b = 78.233;
     float c = 43758.5453;
     float dt= dot(co.xy ,vec2(a,b));
     float sn= mod(dt,3.14159265);
    return 2.0*fract(sin(sn) * c)-1.0;
}*/

float myDistance(vec2 p,vec2 p1)
{
	float x=p1.x-p.x;
	float y=(p1.y-p.y)*u_HoldParam[3];
	return sqrt(x*x+y*y);	
}

bool containPoint()
{
		if(u_HoldParam[0]<=0.0)
		{
			return false;	
		}
		vec2 p=vec2(u_HoldParam[1],u_HoldParam[2]);
		vec2 p1=vec2(v_texCoord.x,v_texCoord.y);
		return myDistance(p1,p)<u_HoldParam[0];
}

void main() 
{ 
	vec2 refractTexCoord;
	vec4 normalMap;
	vec4 normal;
	vec4 refractionColor;
	vec4 textureColor;
	vec4 color;
	
	if(containPoint())
	{
		gl_FragColor=refractionColor = texture2D(u_NormalText,v_texCoord);
		return;	
	}
	
	refractTexCoord=v_texCoord;
	normalMap = texture2D(u_BumpText, v_texCoord);
	normal = (normalMap * 2.0) - 1.0;
	refractTexCoord =  refractTexCoord+normal.xy * u_RndFactor;
	refractionColor = texture2D(u_NormalText, refractTexCoord);
  textureColor = texture2D(u_IceText, v_texCoord);
  color = mix(refractionColor, textureColor, 2.5*u_RndFactor);
  gl_FragColor = color;
}